#!/bin/bash -e

OS="$1"
FILES_DIR="container_setup"
DOCKER_FILE_DIR="$OS"
IMAGE_NAME="$OS"
IMAGE_CONF="$OS.conf"
IMAGE_TAG="latest"
IMAGE_ARCHIVE_FILE="$OS.tar"
DESC_FILE="$OS.desc"
CONFIG_YAML="$OS.sbom_config.yaml"
CONFIG_YAML_TMPL="$CONFIG_YAML.tmpl"
INFO_FILE="info.json"
CONF_DIR=conf

source scripts/util.sh

get_carch
get_product

(
	cd "$FILES_DIR"/"$DOCKER_FILE_DIR"
	podman rmi "$IMAGE_NAME" 2>/dev/null || true
	podman build -t "localhost/$IMAGE_NAME":"$IMAGE_TAG" \
		--arch "$CARCH" ${CVARIANT:+--variant "$CVARIANT"} \
		--build-arg ARCH="$IMGARCH" .

	cd ..
	rm -f "$IMAGE_ARCHIVE_FILE"
	podman save -o "$IMAGE_ARCHIVE_FILE" "localhost/$IMAGE_NAME":"$IMAGE_TAG"

	if [[ "$PRODUCT" == "A9E" && "$IMAGE_NAME" == "at-debian-image" ]]; then
		sed -i "s/^\(.*\) \(#G4X2\)/\2 \1/" \
				"$CONF_DIR/$IMAGE_CONF" \
			|| error "Could not update config for $IMAGE_CONF"
	fi
	mkswu --update-version "$DESC_FILE"
	version=$(awk -F= '$1 == "swdesc_option version" { print $2 }' "$DESC_FILE")
	sed -e "s/{{VERSION}}/$version/g" "$CONFIG_YAML_TMPL" > "$CONFIG_YAML"
	mkswu "$DESC_FILE"
)
